#include "main.h"
#include "create_automata.h"

#define __A_01 "(and (= a0 x0) (= b0 a1) (= b0 c0) (<= 0 i0) (<= (+ 2 i0) l0) (= j0 0) (= j1 (+ j0 1)) (= i1 i0) (= l0 l1) (= x0 x1))"
#define __A_11 "(and (= b0 a1) (= b0 c0) (<= j0 (- i0 1)) (= j1 (+ j0 1)) (= i1 i0) (= l0 l1) (= x0 x1))"
#define __A_12 "(and (= a1 b0) (= b0 c0) (= j0 i0) (= j1 (+ j0 1)) (= i1 i0) (= l0 l1) (= x0 x1))"
#define __A_22 "(and (= a0 b0) (= b0 c0) (<= j0 (- l0 1)) (= j1 (+ j0 1)) (= i1 i0) (= l0 l1) (= x0 x1))"
#define __A_23 "(= j0 l0)"

#define __B_01 "(and (= a0 x0) (= c0 a1) (<= 0 i0) (<= (+ 2 i0) l0) (= j0 0) (= j1 (+ j0 1)) (= i1 i0) (= l0 l1) (= x0 x1))"
#define __B_11 "(and (= c0 a1) (<= j0 (- i0 1)) (= j1 (+ j0 1)) (= i1 i0) (= l0 l1) (= x0 x1))"
#define __B_12 "(and (= c0 a1) (= j0 (+ i0 0)) (= j1 (+ j0 1)) (= i1 i0) (= l0 l1) (= x0 x1))"
#define __B_22 "(and (= c0 a0) (<= j0 (- l0 1)) (= j1 (+ j0 1)) (= i1 i0) (= l0 l1) (= x0 x1))"
#define __B_23 "(= j0 l0)"

std::vector<automaton> get_lhs_automaton_concrete(msat_env env) {
  automaton res;
  /* alphabet */
  res.alphabet.insert("tau");

  /* variables */
  res.vars.insert("a");
  res.vars.insert("b");
  res.vars.insert("c");
  res.vars.insert("i");
  res.vars.insert("j");
  res.vars.insert("l");
  res.vars.insert("x");

  create_msat_variables(env,res.vars,msat_get_integer_type(env));
  
  /* init states */
  res.init_states.insert(0);
  /* final states */
  res.final_states.insert(3);
  /* create rules */
  create_rule(res.trans,env,0,"tau",1,__A_01);
  create_rule(res.trans,env,1,"tau",1,__A_11);
  create_rule(res.trans,env,1,"tau",2,__A_12);
  create_rule(res.trans,env,2,"tau",2,__A_22);
  create_rule(res.trans,env,2,"tau",3,__A_23);

  std::vector<automaton> res_v;		
  res_v.push_back(res);
  return res_v;
}

automaton get_rhs_automaton_concrete(msat_env env) {
  automaton res;
  /* alphabet */
  res.alphabet.insert("tau");

  /* variables */
  res.vars.insert("a");
  res.vars.insert("b");
  res.vars.insert("c");
  res.vars.insert("i");
  res.vars.insert("j");
  res.vars.insert("l");
  res.vars.insert("x");

  create_msat_variables(env,res.vars,msat_get_integer_type(env));
  
  /* init states */
  res.init_states.insert(0);
  /* final states */
  res.final_states.insert(3);
  /* create rules */
  create_rule(res.trans,env,0,"tau",1,__B_01);
  create_rule(res.trans,env,1,"tau",1,__B_11);
  create_rule(res.trans,env,1,"tau",2,__B_12);
  create_rule(res.trans,env,2,"tau",2,__B_22);
  create_rule(res.trans,env,2,"tau",3,__B_23);  

  return res;
}



