#include "main.h"
#include "create_automata.h"


std::vector<automaton> get_lhs_automaton_concrete(msat_env env){
	automaton res;
	std::vector<automaton> res_v;		
	/* alphabet */
	res.alphabet.insert("a");
	/* variables */
	res.vars.insert("i");
	res.vars.insert("n");
	res.vars.insert("j");
	res.vars.insert("a");
	res.vars.insert("b");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* init states */
	res.init_states.insert(0);
	/* final states */
	res.final_states.insert(2);
	/* create rules */
	create_rule(res.trans,env,0,"a",1,"(and (< 0 n1) (= 0 j1 ) (= i1 (- n1 1)))");
	create_rule(res.trans,env,1,"a",1,"(and (< j0 i0 ) (= b1 a0) (= j1 (+ j0 1)) (= n0 n1) (= i0 i1))");
	create_rule(res.trans,env,1,"a",2,"(and (= j0 i0 ) (= j1 (+ j0 1)) (= n0 n1) (= i0 i1))");
	res_v.push_back(res);	
	return res_v;

}

automaton get_rhs_automaton_concrete(msat_env env){
	automaton res;
	/* alphabet */
	res.alphabet.insert("a");
	/* variables */
	res.vars.insert("i");
	res.vars.insert("n");
	res.vars.insert("j");
	res.vars.insert("a");
	res.vars.insert("b");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* init states */
	res.init_states.insert(0);
	/* final states */
	res.final_states.insert(2);
	/* create rules */
	create_rule(res.trans,env,0,"a",1,"(and (< 0 n1) (= 0 j1 ) (< i1 n1) ( <= 0 i1)))");
	create_rule(res.trans,env,1,"a",1,"(and (< j0 i0 ) (= b1 a0) (= j1 (+ j0 1)) (= n0 n1) (= i0 i1))");
	create_rule(res.trans,env,1,"a",2,"(and (= j0 i0 ) (= j1 (+ j0 1)) (= n0 n1) (= i0 i1))");
	create_rule(res.trans,env,2,"a",2,"(and (< j0 n0) (= j1 (+ j0 1)) (= n0 n1) (= i0 i1))");


	return res;

}
