#include "main.h"
#include "create_automata.h"


std::vector<automaton> get_lhs_automaton_concrete(msat_env env){
	automaton res;
	std::vector<automaton> res_v;		
	/* alphabet */
	res.alphabet.insert("a");
	/* variables */
	res.vars.insert("a");
	res.vars.insert("b");
	res.vars.insert("c");
	res.vars.insert("na");
	res.vars.insert("nb");
	res.vars.insert("nc");
	res.vars.insert("i");
	res.vars.insert("j");
	res.vars.insert("k");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* init states */
	res.init_states.insert(0);
	/* final states */
	res.final_states.insert(2);
	/* create rules */
	create_rule(res.trans,env,0,"a",1,"(and (>= na1 0) (= i1 0) (= j1 0) (= k1 0))");
	create_rule(res.trans,env,1,"a",1,"(and (< i0 na0) (< a0 0) (= a0 b0) (= i1 (+ i0 1)) (= j1 (+ j0 1)) (= k1 k0) (= c1 c0) (= na1 na0))");
	create_rule(res.trans,env,1,"a",1,"(and (< i0 na0) (>= a0 0) (= a0 c0) (= i1 (+ i0 1)) (= k1 (+ k0 1)) (= j1 j0) (= b1 b0) (= na1 na0))");
	create_rule(res.trans,env,1,"a",2,"(and (= i0 na0) (= nb0 j0) (= nc0 k0))");
	res_v.push_back(res);	
	return res_v;

}

automaton get_rhs_automaton_concrete(msat_env env){
	automaton res;
	/* alphabet */
	res.alphabet.insert("a");
	/* variables */
	res.vars.insert("b");
	res.vars.insert("nb");
	res.vars.insert("j");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* init states */
	res.init_states.insert(0);
	/* final states */
	res.final_states.insert(2);
	/* create rules */
	create_rule(res.trans,env,0,"a",1,"(= j1 0)");
	create_rule(res.trans,env,1,"a",1,"(and (= j1 j0) (= b1 b0))");
	create_rule(res.trans,env,1,"a",1,"(and (= j1 (+ j0 1)) (< b0 0))");
	create_rule(res.trans,env,1,"a",2,"(= j0 nb0)");
	return res;

}
