#include "main.h"
#include "create_automata.h"

std::vector<automaton> get_lhs_automaton_concrete(msat_env env) {
  automaton res;
  /* alphabet */
  res.alphabet.insert("x");
  /* variables */
  res.vars.insert("a0");
  res.vars.insert("lp");
  res.vars.insert("a1");
  res.vars.insert("a2");
  res.vars.insert("xp");
  res.vars.insert("l");
  res.vars.insert("N");
  res.vars.insert("I");
  res.vars.insert("x");
  res.vars.insert("ip");
  res.vars.insert("i");
  create_msat_variables(env,res.vars,msat_get_integer_type(env));
  /* init states */
  res.init_states.insert(0);
  /* final states */
  res.final_states.insert(1);
//  res.final_states.insert(2);
//  res.final_states.insert(3);
//  res.final_states.insert(4);
//  res.final_states.insert(5);
//  res.final_states.insert(6);
//  res.final_states.insert(7);
  /* create rules */
  create_rule(res.trans,env,2,"x",3,"(and (= N1 N0) (= xp1 xp0) (= l1 l0) (= x1 x0) (= lp1 lp0) (= I1 (+ i1 1)) (= a11 a20) (= i1 i0) (= i1 I0) (= ip1 ip0) (>= N1 (+ i1 2)) ) ");
  create_rule(res.trans,env,4,"x",4,"(and (= a10 a20) (= a00 a20) (= x1 x0) (= xp1 xp0) (= l1 l0) (= N1 N0) (= lp1 lp0) (= i1 i0) (= I1 (+ I0 1)) (= ip1 ip0) (<= I1 (- l1 1)) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,4,"x",1,"(and (= l1 l0) (= I1 N1) (= N1 N0) (= xp1 xp0) (= x1 x0) (= a10 a20) (= a00 a20) (= lp1 lp0) (= N1 (+ I0 1)) (= i1 i0) (= ip1 ip0) ) ");
  create_rule(res.trans,env,4,"x",5,"(and (= a10 a20) (= a00 a20) (= x1 x0) (= xp1 xp0) (= lp1 lp0) (= I1 l1) (= l1 l0) (= N1 N0) (= l1 (+ I0 1)) (= i1 i0) (= ip1 ip0) (<= l1 (- N1 1)) ) ");
  create_rule(res.trans,env,3,"x",3,"(and (= xp1 xp0) (= l1 l0) (= N1 N0) (= lp1 lp0) (= x1 x0) (= a10 a20) (= i1 i0) (= I1 (+ I0 1)) (= ip1 ip0) (<= I1 (- l1 1)) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,3,"x",1,"(and (= lp1 lp0) (= x1 x0) (= xp1 xp0) (= a10 a20) (= l1 l0) (= I1 N1) (= N1 N0) (= N1 (+ I0 1)) (= i1 i0) (= ip1 ip0) ) ");
  create_rule(res.trans,env,2,"x",1,"(and (= x1 x0) (= l1 l0) (= I1 N1) (= N1 N0) (= xp1 xp0) (= lp1 lp0) (= N1 (+ I0 1)) (= i1 i0) (= ip1 ip0) ) ");
  create_rule(res.trans,env,2,"x",2,"(and (= lp1 lp0) (= N1 N0) (= x1 x0) (= xp1 xp0) (= l1 l0) (= a11 a20) (= i1 i0) (= I1 (+ I0 1)) (= ip1 ip0) (<= I1 (- N1 1)) (<= I1 i1) ) ");
  create_rule(res.trans,env,5,"x",1,"(and (= x1 x0) (= xp1 xp0) (= I1 N1) (= N1 N0) (= l1 l0) (= lp1 lp0) (= N1 (+ I0 1)) (= i1 i0) (= ip1 ip0) ) ");
  create_rule(res.trans,env,5,"x",5,"(and (= lp1 lp0) (= xp1 xp0) (= l1 l0) (= x1 x0) (= N1 N0) (= i1 i0) (= I1 (+ I0 1)) (= ip1 ip0) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,3,"x",5,"(and (= x1 x0) (= lp1 lp0) (= a10 a20) (= I1 l1) (= l1 l0) (= N1 N0) (= xp1 xp0) (= l1 (+ I0 1)) (= i1 i0) (= ip1 ip0) (<= l1 (- N1 1)) ) ");
  create_rule(res.trans,env,0,"x",6,"(and (= I1 1) (= I0 0) (= xp1 x1) (= xp1 xp0) (= xp1 x0) (= xp1 a00) (= N1 N0) (= lp1 l0) (= lp1 lp0) (= ip1 (+ i1 1)) (= ip1 (+ i0 1)) (= l1 lp1) (= ip1 ip0) (= a01 a10) (= a01 a20) (<= ip1 (- lp1 1)) (>= ip1 3) (>= N1 lp1) ) ");
  create_rule(res.trans,env,0,"x",4,"(and (= ip1 1) (= I1 1) (= i0 0) (= i1 0) (= I0 0) (= xp1 x1) (= xp1 xp0) (= xp1 x0) (= xp1 a10) (= xp1 a00) (= N1 N0) (= lp1 l0) (= lp1 lp0) (= ip0 1) (= a11 a20) (= l1 lp1) (>= lp1 2) (>= N1 lp1) ) ");
  create_rule(res.trans,env,0,"x",7,"(and (= I1 1) (= i1 1) (= I0 0) (= i0 1) (= xp1 a00) (= xp1 x0) (= xp1 xp0) (= xp1 x1) (= N1 N0) (= lp1 l0) (= lp1 lp0) (= ip0 2) (= ip1 2) (= l1 lp1) (= a01 a10) (= a01 a20) (>= lp1 3) (>= N1 lp1) ) ");
  create_rule(res.trans,env,7,"x",4,"(and (= lp1 lp0) (= x1 x0) (= l1 l0) (= N1 N0) (= xp1 xp0) (= I1 (+ i1 1)) (= a11 a20) (= i1 i0) (= i1 I0) (= ip1 ip0) (= a00 a10) (>= l1 (+ i1 2)) (>= N1 (+ i1 2)) ) ");
  create_rule(res.trans,env,7,"x",3,"(and (= lp1 lp0) (= x1 x0) (= N1 N0) (= l1 l0) (= I1 l1) (= xp1 xp0) (= l1 (+ i1 1)) (= a11 a20) (= l1 (+ I0 1)) (= l1 (+ i0 1)) (= ip1 ip0) (= a00 a10) (<= l1 (- N1 1)) ) ");
  create_rule(res.trans,env,7,"x",2,"(and (= x1 x0) (= lp1 lp0) (= N1 N0) (= l1 l0) (= I1 l1) (= xp1 xp0) (= a11 a20) (= l1 (+ I0 1)) (= i1 i0) (= ip1 ip0) (= a00 a10) (<= l1 (- N1 1)) (<= l1 i1) ) ");
  create_rule(res.trans,env,7,"x",1,"(and (= xp1 xp0) (= I1 N1) (= N1 N0) (= x1 x0) (= lp1 lp0) (= l1 l0) (= N1 (+ I0 1)) (= i1 i0) (= ip1 ip0) (= a00 a10) ) ");
  create_rule(res.trans,env,6,"x",7,"(and (= a01 a10) (= lp1 lp0) (= x1 x0) (= l1 l0) (= N1 N0) (= xp1 xp0) (= a01 a20) (= I1 i1) (= i1 i0) (= i1 (+ I0 1)) (= ip1 ip0) (>= N1 (+ i1 1)) ) ");
  create_rule(res.trans,env,6,"x",6,"(and (= a01 a10) (= l1 l0) (= lp1 lp0) (= x1 x0) (= xp1 xp0) (= N1 N0) (= a01 a20) (= i1 i0) (= I1 (+ I0 1)) (= ip1 ip0) (<= I1 (- N1 1)) (<= I1 (- i1 1)) ) ");
  create_rule(res.trans,env,7,"x",7,"(and (= lp1 lp0) (= xp1 xp0) (= N1 N0) (= l1 l0) (= x1 x0) (= a11 a20) (= i1 i0) (= I1 (+ I0 1)) (= ip1 ip0) (= a00 a10) (<= I1 (- N1 1)) (<= I1 (- l1 1)) (<= I1 i1) ) ");
  create_rule(res.trans,env,6,"x",1,"(and (= x1 x0) (= lp1 lp0) (= I1 N1) (= N1 N0) (= l1 l0) (= xp1 xp0) (= N1 (+ I0 1)) (= i1 i0) (= ip1 ip0) ) ");

  /* invariants */
  add_invariant(res,env,6,"(and  (<= lp0 N0) (<= ip0 (- lp0 1)) (= lp0 l0) (= ip0 (+ i0 1)) (= xp0 x0) (or (and (= I0 1) (>= ip0 3)) (and (>= ip0 (+ I0 2)) (>= I0 2))))");
  //add_invariant(res,env,4,"(and (= xp0 x0) (<= lp0 N0) (= lp0 l0) (or (and (= ip0 1) (= i0 0) (>= lp0 (+ I0 1)) (>= I0 2)) (and (= ip0 1) (= I0 1) (= i0 0) (>= lp0 2))  (and (= ip0 (+ i0 1))  (>= ip0 2) (>= lp0 (+ I0 1)) (<= ip0 I0))))");
  //add_invariant(res,env,4,"(and (= a20 a00) (= a10 a20) (or (= I0 (- N0 1)) (and (<= I0 (- N0 2)) (<= I0 (- l0 1)))))");
  add_invariant(res,env,4,"(and (= a20 a00) (= a10 a20) (or (= I0 (- N0 1)) (and (<= I0 (- N0 2)) (<= I0 (- l0 1)))) (= xp0 x0) (<= lp0 N0) (= lp0 l0) (or (and (= ip0 1) (= i0 0) (>= lp0 (+ I0 1)) (>= I0 2)) (and (= ip0 1) (= I0 1) (= i0 0) (>= lp0 2))  (and (= ip0 (+ i0 1))  (>= ip0 2) (>= lp0 (+ I0 1)) (<= ip0 I0)))   )");
 add_invariant(res,env,7,"(and (= l0 I0) (= N0 (+ l0 1)) (>= l0 (+ i0 4)) (>= i0 3))");
 //add_invariant(res,env,5,"(and (= l0 I0) (= N0 (+ l0 1)) (>= l0 (+ i0 4)) (>= i0 3))");
 add_invariant(res,env,5,"(and (<= I0 (- N0 1)) (= l0 I0) (= N0 (+ l0 1)) (>= l0 (+ i0 4)) (>= i0 3))");
 //add_invariant(res,env,2,"(and (= l0 I0) (= N0 (+ l0 1)) (>= l0 (+ i0 4)) (>= i0 3))");
 add_invariant(res,env,2,"(and (or (= I0 (- N0 1)) (and (<= I0 i0) (<= i0 (- N0 3)) (<= i0 (- l0 2))) (and (>= i0 (- N0 2)) (<= I0 (- N0 2)))) (= l0 I0) (= N0 (+ l0 1)) (>= l0 (+ i0 4)) (>= i0 3))");
 //add_invariant(res,env,3,"(and (= l0 I0) (= N0 (+ l0 1)) (>= l0 (+ i0 4)) (>= i0 3))");
 add_invariant(res,env,3,"(and (or (and (= a10 a20) (= I0 (- N0 1))) (and (= a10 a20) (<= I0 (- N0 2)) (<= I0 (- l0 1)))) (= l0 I0) (= N0 (+ l0 1)) (>= l0 (+ i0 4)) (>= i0 3))");

  std::vector<automaton> res_v;		
  res_v.push_back(res);
  return res_v;
}

automaton get_rhs_automaton_concrete(msat_env env) {
  automaton res;
  /* alphabet */
  res.alphabet.insert("x");
  /* variables */
  res.vars.insert("a0");
  res.vars.insert("lp");
  res.vars.insert("a1");
  res.vars.insert("a2");
  res.vars.insert("xp");
  res.vars.insert("l");
  res.vars.insert("N");
  res.vars.insert("I");
  res.vars.insert("x");
  res.vars.insert("ip");
  res.vars.insert("i");
  create_msat_variables(env,res.vars,msat_get_integer_type(env));
  /* init states */
  res.init_states.insert(0);
  /* final states */
  res.final_states.insert(1);
//  res.final_states.insert(2);
//  res.final_states.insert(3);
//  res.final_states.insert(4);
//  res.final_states.insert(5);
  /* create rules */
  create_rule(res.trans,env,2,"x",3,"(and (= xp1 xp0) (= l1 l0) (= lp1 lp0) (= x1 x0) (= N1 N0) (= a01 a20) (= I1 ip1) (= i1 i0) (= ip1 (+ I0 1)) (= ip1 ip0) (>= N1 (+ ip1 1)) ) ");
  create_rule(res.trans,env,2,"x",2,"(and (= l1 l0) (= xp1 xp0) (= lp1 lp0) (= x1 x0) (= N1 N0) (= a01 a20) (= i1 i0) (= I1 (+ I0 1)) (= ip1 ip0) (<= I1 (- N1 1)) (<= I1 (- ip1 1)) ) ");
  create_rule(res.trans,env,3,"x",1,"(and (= x1 x0) (= l1 l0) (= xp1 xp0) (= I1 N1) (= N1 N0) (= lp1 lp0) (= N1 (+ I0 1)) (= i1 i0) (= ip1 ip0) ) ");
  create_rule(res.trans,env,0,"x",4,"(and (= I1 1) (= I0 0) (= l1 l0) (= lp1 lp0) (= N1 N0) (= x1 x0) (= xp1 a00) (= xp1 xp0) (= i1 i0) (= ip1 ip0) (= a01 a20) (<= ip1 (- lp1 1)) (>= N1 2) (>= ip1 2) ) ");
  create_rule(res.trans,env,3,"x",3,"(and (= l1 l0) (= xp1 xp0) (= N1 N0) (= lp1 lp0) (= x1 x0) (= i1 i0) (= I1 (+ I0 1)) (= ip1 ip0) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,0,"x",5,"(and (= I1 1) (= I0 0) (= l1 l0) (= N1 N0) (= xp1 a00) (= xp1 xp0) (= x1 x0) (= lp1 lp0) (= xp1 a20) (= i1 i0) (= ip1 ip0) (<= ip1 0) (>= N1 2) (>= lp1 2) ) ");
  create_rule(res.trans,env,2,"x",1,"(and (= xp1 xp0) (= l1 l0) (= I1 N1) (= N1 N0) (= x1 x0) (= lp1 lp0) (= N1 (+ I0 1)) (= i1 i0) (= ip1 ip0) ) ");
  create_rule(res.trans,env,5,"x",3,"(and (= a00 a20) (= l1 l0) (= x1 x0) (= xp1 xp0) (= I1 lp1) (= lp1 lp0) (= N1 N0) (= lp1 (+ I0 1)) (= i1 i0) (= ip1 ip0) (>= N1 (+ lp1 1)) ) ");
  create_rule(res.trans,env,5,"x",5,"(and (= a00 a20) (= xp1 xp0) (= l1 l0) (= lp1 lp0) (= N1 N0) (= x1 x0) (= i1 i0) (= I1 (+ I0 1)) (= ip1 ip0) (<= I1 (- lp1 1)) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,0,"x",1,"(and (= I1 1) (= N0 1) (= I0 0) (= l1 l0) (= lp1 lp0) (= N1 1) (= xp1 a00) (= xp1 xp0) (= x1 x0) (= xp1 a20) (= i1 i0) (= ip1 ip0) (<= ip1 0) (>= lp1 1) ) ");
  create_rule(res.trans,env,0,"x",3,"(and (= I1 1) (= I0 0) (= l1 l0) (= x1 x0) (= lp1 lp0) (= N1 N0) (= xp1 xp0) (= xp1 a00) (= i1 i0) (= ip1 ip0) (<= ip1 0) (>= ip1 lp1) (>= N1 2) ) ");
  create_rule(res.trans,env,4,"x",1,"(and (= I1 N1) (= N1 N0) (= lp1 lp0) (= l1 l0) (= xp1 xp0) (= x1 x0) (= N1 (+ I0 1)) (= i1 i0) (= ip1 ip0) ) ");
  create_rule(res.trans,env,4,"x",5,"(and (= x1 x0) (= lp1 lp0) (= l1 l0) (= N1 N0) (= xp1 xp0) (= a01 a20) (= I1 ip1) (= i1 i0) (= ip1 (+ I0 1)) (= ip1 ip0) (>= N1 (+ ip1 1)) ) ");
  create_rule(res.trans,env,4,"x",4,"(and (= lp1 lp0) (= l1 l0) (= x1 x0) (= N1 N0) (= xp1 xp0) (= a01 a20) (= i1 i0) (= I1 (+ I0 1)) (= ip1 ip0) (<= I1 (- N1 1)) (<= I1 (- ip1 1)) ) ");
  create_rule(res.trans,env,5,"x",1,"(and (= a00 a20) (= l1 l0) (= I1 N1) (= N1 N0) (= x1 x0) (= lp1 lp0) (= xp1 xp0) (= N1 (+ I0 1)) (= i1 i0) (= ip1 ip0) ) ");
  create_rule(res.trans,env,0,"x",1,"(and (= I1 1) (= N0 1) (= I0 0) (= l1 l0) (= x1 x0) (= xp1 a00) (= xp1 xp0) (= N1 1) (= lp1 lp0) (= i1 i0) (= ip1 ip0) (<= ip1 (- lp1 1)) (>= ip1 1) ) ");
  create_rule(res.trans,env,0,"x",3,"(and (= lp0 1) (= I1 1) (= I0 0) (= N1 N0) (= lp1 1) (= xp1 a00) (= xp1 xp0) (= l1 l0) (= x1 x0) (= xp1 a20) (= i1 i0) (= ip1 ip0) (<= ip1 0) (>= N1 2) ) ");
  create_rule(res.trans,env,0,"x",1,"(and (= N0 1) (= I1 1) (= I0 0) (= l1 l0) (= xp1 a00) (= xp1 xp0) (= x1 x0) (= lp1 lp0) (= N1 1) (= i1 i0) (= ip1 ip0) (<= ip1 (- lp1 1)) (<= lp1 0) ) ");
  create_rule(res.trans,env,0,"x",3,"(and (= I1 1) (= ip1 1) (= I0 0) (= ip0 1) (= N1 N0) (= xp1 a00) (= xp1 xp0) (= lp1 lp0) (= l1 l0) (= x1 x0) (= i1 i0) (= a01 a20) (>= N1 2) (<= lp1 1) ) ");
  create_rule(res.trans,env,0,"x",2,"(and (= I1 1) (= I0 0) (= x1 x0) (= xp1 xp0) (= xp1 a00) (= l1 l0) (= N1 N0) (= lp1 lp0) (= a01 a20) (= i1 i0) (= ip1 ip0) (>= ip1 lp1) (>= N1 2) (>= ip1 2) ) ");
  create_rule(res.trans,env,0,"x",3,"(and (= I1 1) (= I0 0) (= l1 l0) (= N1 N0) (= x1 x0) (= xp1 xp0) (= xp1 a00) (= lp1 lp0) (= i1 i0) (= ip1 ip0) (>= N1 2) (<= ip1 (- lp1 1)) (<= lp1 0) ) ");
  create_rule(res.trans,env,0,"x",1,"(and (= I1 1) (= N0 1) (= I0 0) (= x1 x0) (= N1 1) (= xp1 xp0) (= xp1 a00) (= lp1 lp0) (= l1 l0) (= i1 i0) (= ip1 ip0) (>= ip1 lp1) ) ");
  create_rule(res.trans,env,0,"x",5,"(and (= ip1 1) (= I1 1) (= I0 0) (= ip0 1) (= xp1 a00) (= xp1 xp0) (= x1 x0) (= l1 l0) (= N1 N0) (= lp1 lp0) (= i1 i0) (= a01 a20) (>= lp1 2) (>= N1 2) ) ");
  return res;
}
