#include "main.h"
#include "create_automata.h"

std::vector<automaton> get_lhs_automaton_concrete(msat_env env) {
  automaton res;
  /* alphabet */
  res.alphabet.insert("x");
  /* variables */
  res.vars.insert("a2p");
  res.vars.insert("a3p");
  res.vars.insert("N");
  res.vars.insert("I");
  res.vars.insert("i3p");
  res.vars.insert("i2p");
  res.vars.insert("a1");
  res.vars.insert("a2");
  res.vars.insert("i1p");
  res.vars.insert("a3");
  res.vars.insert("i3");
  res.vars.insert("i2");
  res.vars.insert("x");
  res.vars.insert("i1");
  create_msat_variables(env,res.vars,msat_get_integer_type(env));
  /* init states */
  res.init_states.insert(0);
  /* final states */
  res.final_states.insert(1);
  /* create rules */
  create_rule(res.trans,env,2,"x",3,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= x1 x0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i31) (= a3p0 a30) (= x1 a2p0) (= i31 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 (- i11 1)) (<= i31 i21) ) ");
  create_rule(res.trans,env,2,"x",4,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i31) (= x1 x0) (= i31 (+ i21 1)) (= a3p0 a30) (= x1 a2p0) (= i31 (+ I0 1)) (= i31 (+ i20 1)) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 (- i11 1)) ) ");
  create_rule(res.trans,env,2,"x",2,"(and (= i1p1 i1p0) (= x1 x0) (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= x1 a2p0) (= a3p0 a30) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= I1 (- N1 1)) (<= I1 (- i11 1)) (<= I1 (- i31 1)) (<= I1 i21) ) ");
  create_rule(res.trans,env,2,"x",5,"(and (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= x1 x0) (= i1p1 i1p0) (= I1 (+ i21 1)) (= a3p0 a30) (= x1 a2p0) (= i21 I0) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (>= N1 (+ i21 2)) (<= i21 (- i11 2)) (>= i31 (+ i21 2)) ) ");
  create_rule(res.trans,env,6,"x",6,"(and (= i31 i30) (= N1 N0) (= i11 i10) (= x1 a10) (= x1 x0) (= i3p1 i3p0) (= i1p1 i1p0) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= x1 0) (<= I1 i11) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,6,"x",7,"(and (= I1 (+ i11 1)) (= i1p1 i1p0) (= x1 a10) (= x1 x0) (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= i11 I0) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (>= N1 (+ i11 2)) ) ");
  create_rule(res.trans,env,2,"x",8,"(and (= i1p1 i1p0) (= x1 x0) (= N1 N0) (= i31 i10) (= i31 i30) (= I1 i31) (= i3p1 i3p0) (= x1 a2p0) (= a3p0 a30) (= i31 (+ I0 1)) (= i21 i20) (= i31 i11) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 i21) ) ");
  create_rule(res.trans,env,2,"x",6,"(and (= i3p1 i3p0) (= N1 N0) (= i31 i10) (= i31 i30) (= I1 i31) (= i1p1 i1p0) (= x1 x0) (= i31 (+ i21 1)) (= a3p0 a30) (= x1 a2p0) (= i31 (+ I0 1)) (= i31 (+ i20 1)) (= i31 i11) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,5,"x",6,"(and (= x1 x0) (= i1p1 i1p0) (= N1 N0) (= i31 i10) (= i31 i30) (= I1 i31) (= i3p1 i3p0) (= a3p0 a30) (= i31 (+ I0 1)) (= i21 i20) (= i31 i11) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,7,"x",7,"(and (= i1p1 i1p0) (= i31 i30) (= i11 i10) (= x1 x0) (= N1 N0) (= i3p1 i3p0) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,5,"x",5,"(and (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i31 i30) (= x1 x0) (= i3p1 i3p0) (= a3p0 a30) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= I1 (- N1 1)) (<= I1 (- i11 1)) (<= I1 (- i31 1)) ) ");
  create_rule(res.trans,env,5,"x",4,"(and (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i31) (= i1p1 i1p0) (= x1 x0) (= a3p0 a30) (= i31 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 (- i11 1)) ) ");
  create_rule(res.trans,env,2,"x",9,"(and (= i3p1 i3p0) (= i1p1 i1p0) (= x1 x0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i11) (= a3p0 a30) (= x1 a2p0) (= i11 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (>= N1 (+ i11 1)) (>= i31 (+ i11 1)) (>= i21 i11) ) ");
  create_rule(res.trans,env,2,"x",1,"(and (= i31 i30) (= i3p1 i3p0) (= N1 N0) (= I1 N1) (= x1 x0) (= i1p1 i1p0) (= i11 i10) (= a3p0 a30) (= x1 a2p0) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,7,"x",1,"(and (= i11 i10) (= i1p1 i1p0) (= i31 i30) (= x1 x0) (= i3p1 i3p0) (= I1 N1) (= N1 N0) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) ) ");
  create_rule(res.trans,env,2,"x",10,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= x1 x0) (= N1 N0) (= i31 i30) (= i21 (- i10 1)) (= I1 (+ i21 1)) (= a3p0 a30) (= x1 a2p0) (= i21 I0) (= i21 i20) (= i21 (- i11 1)) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (>= N1 (+ i21 2)) (>= i31 (+ i21 2)) ) ");
  create_rule(res.trans,env,3,"x",1,"(and (= I1 N1) (= N1 N0) (= x1 x0) (= i1p1 i1p0) (= i11 i10) (= i31 i30) (= i3p1 i3p0) (= x1 a2p0) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) ) ");
  create_rule(res.trans,env,3,"x",6,"(and (= i31 i30) (= i3p1 i3p0) (= x1 x0) (= i1p1 i1p0) (= N1 N0) (= i21 (- i10 1)) (= I1 (+ i21 1)) (= x1 a2p0) (= i21 I0) (= i21 i20) (= i21 (- i11 1)) (= i2p1 i2p0) (>= N1 (+ i21 2)) ) ");
  create_rule(res.trans,env,3,"x",8,"(and (= i1p1 i1p0) (= x1 x0) (= N1 N0) (= i11 i10) (= I1 i11) (= i31 i30) (= i3p1 i3p0) (= x1 a2p0) (= i11 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= N1 (+ i11 1)) (>= i21 i11) ) ");
  create_rule(res.trans,env,11,"x",1,"(and (= i3p1 i3p0) (= i11 i10) (= x1 x0) (= I1 N1) (= N1 N0) (= i1p1 i1p0) (= i31 i30) (= a2p0 a20) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) ) ");
  create_rule(res.trans,env,5,"x",1,"(and (= i3p1 i3p0) (= i1p1 i1p0) (= i11 i10) (= i31 i30) (= x1 x0) (= I1 N1) (= N1 N0) (= a3p0 a30) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,5,"x",10,"(and (= x1 x0) (= I1 i11) (= i31 i30) (= i11 i10) (= N1 N0) (= i3p1 i3p0) (= i1p1 i1p0) (= a3p0 a30) (= i11 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (>= i31 (+ i11 1)) (>= N1 (+ i11 1)) ) ");
  create_rule(res.trans,env,3,"x",4,"(and (= i3p1 i3p0) (= x1 x0) (= i1p1 i1p0) (= i11 i10) (= N1 N0) (= i31 i30) (= I1 (+ i21 1)) (= x1 a2p0) (= i21 i20) (= i21 I0) (= i2p1 i2p0) (<= i21 (- i11 2)) (>= N1 (+ i21 2)) ) ");
  create_rule(res.trans,env,3,"x",3,"(and (= i3p1 i3p0) (= i1p1 i1p0) (= x1 x0) (= i11 i10) (= N1 N0) (= i31 i30) (= x1 a2p0) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (<= I1 (- i11 1)) (<= I1 (- N1 1)) (<= I1 i21) ) ");
  create_rule(res.trans,env,8,"x",12,"(and (= I1 (+ i11 1)) (= i3p1 i3p0) (= i1p1 i1p0) (= i31 i30) (= x1 a10) (= x1 x0) (= N1 N0) (= i11 i10) (= x1 a2p0) (= i11 I0) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (>= i21 (+ i11 1)) (>= N1 (+ i11 2)) ) ");
  create_rule(res.trans,env,8,"x",7,"(and (= x1 x0) (= N1 N0) (= i1p1 i1p0) (= i3p1 i3p0) (= i31 i30) (= x1 a10) (= I1 (+ i21 1)) (= x1 a2p0) (= i21 i10) (= i21 I0) (= i21 i20) (= i2p1 i2p0) (= i21 i11) (>= x1 0) (>= N1 (+ i21 2)) ) ");
  create_rule(res.trans,env,8,"x",1,"(and (= i11 i10) (= i1p1 i1p0) (= x1 a10) (= x1 x0) (= N1 N0) (= I1 N1) (= i3p1 i3p0) (= i31 i30) (= x1 a2p0) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= x1 0) ) ");
  create_rule(res.trans,env,8,"x",6,"(and (= x1 x0) (= i31 i30) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i3p1 i3p0) (= x1 a10) (= I1 (+ i21 1)) (= x1 a2p0) (= i21 I0) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (<= i21 (- i11 1)) (>= N1 (+ i21 2)) ) ");
  create_rule(res.trans,env,11,"x",13,"(and (= i31 i30) (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= I1 i11) (= x1 x0) (= i1p1 i1p0) (= a2p0 a20) (= i11 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (>= N1 (+ i11 1)) (>= i21 (+ i11 1)) ) ");
  create_rule(res.trans,env,11,"x",3,"(and (= x1 x0) (= i31 i30) (= N1 N0) (= i11 i10) (= i1p1 i1p0) (= i3p1 i3p0) (= I1 i21) (= a2p0 a20) (= i21 i20) (= i21 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (>= N1 (+ i21 1)) (<= i21 (- i11 1)) ) ");
  create_rule(res.trans,env,11,"x",11,"(and (= i31 i30) (= N1 N0) (= i11 i10) (= i1p1 i1p0) (= i3p1 i3p0) (= x1 x0) (= a2p0 a20) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= I1 (- N1 1)) (<= I1 (- i11 1)) (<= I1 (- i21 1)) ) ");
  create_rule(res.trans,env,11,"x",8,"(and (= i1p1 i1p0) (= i31 i30) (= N1 N0) (= i3p1 i3p0) (= x1 x0) (= i21 i10) (= I1 i21) (= a2p0 a20) (= i21 i20) (= i21 (+ I0 1)) (= i2p1 i2p0) (= i21 i11) (>= a2p0 0) (>= N1 (+ i21 1)) ) ");
  create_rule(res.trans,env,12,"x",7,"(and (= i1p1 i1p0) (= i11 i10) (= i31 i30) (= x1 x0) (= N1 N0) (= i3p1 i3p0) (= I1 (+ i21 1)) (= x1 a2p0) (= i21 i20) (= i21 I0) (= i2p1 i2p0) (>= N1 (+ i21 2)) ) ");
  create_rule(res.trans,env,12,"x",1,"(and (= i3p1 i3p0) (= i1p1 i1p0) (= i11 i10) (= I1 N1) (= N1 N0) (= x1 x0) (= i31 i30) (= x1 a2p0) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) ) ");
  create_rule(res.trans,env,12,"x",12,"(and (= i1p1 i1p0) (= i11 i10) (= i3p1 i3p0) (= i31 i30) (= x1 x0) (= N1 N0) (= x1 a2p0) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (<= I1 (- N1 1)) (<= I1 i21) ) ");
  create_rule(res.trans,env,4,"x",6,"(and (= x1 x0) (= i1p1 i1p0) (= i31 i30) (= I1 i11) (= i11 i10) (= N1 N0) (= i3p1 i3p0) (= i11 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= N1 (+ i11 1)) ) ");
  create_rule(res.trans,env,4,"x",4,"(and (= i1p1 i1p0) (= i31 i30) (= i3p1 i3p0) (= i11 i10) (= N1 N0) (= x1 x0) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (<= I1 (- i11 1)) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,4,"x",1,"(and (= i1p1 i1p0) (= i31 i30) (= i3p1 i3p0) (= I1 N1) (= N1 N0) (= x1 x0) (= i11 i10) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) ) ");
  create_rule(res.trans,env,10,"x",10,"(and (= i3p1 i3p0) (= x1 x0) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i31 i30) (= x1 a10) (= a3p0 a30) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= x1 0) (<= I1 i11) (<= a3p0 (- 0 1)) (<= I1 (- N1 1)) (<= I1 (- i31 1)) ) ");
  create_rule(res.trans,env,10,"x",7,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= x1 a10) (= x1 x0) (= N1 N0) (= i31 i30) (= I1 i31) (= i31 (+ i10 1)) (= a3p0 a30) (= i31 (+ I0 1)) (= i21 i20) (= i31 (+ i11 1)) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,9,"x",7,"(and (= i1p1 i1p0) (= x1 x0) (= i3p1 i3p0) (= N1 N0) (= i31 i30) (= I1 i31) (= x1 a10) (= i31 (+ i10 1)) (= i31 (+ i21 1)) (= a3p0 a30) (= x1 a2p0) (= i31 (+ I0 1)) (= i31 (+ i20 1)) (= i31 (+ i11 1)) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,9,"x",12,"(and (= i3p1 i3p0) (= i1p1 i1p0) (= x1 a10) (= x1 x0) (= N1 N0) (= i31 i30) (= I1 i31) (= i31 (+ i10 1)) (= a3p0 a30) (= x1 a2p0) (= i31 (+ I0 1)) (= i21 i20) (= i31 (+ i11 1)) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 i21) ) ");
  create_rule(res.trans,env,9,"x",14,"(and (= i3p1 i3p0) (= i1p1 i1p0) (= N1 N0) (= i31 i30) (= x1 a10) (= x1 x0) (= I1 (+ i21 1)) (= a3p0 a30) (= i21 i10) (= x1 a2p0) (= i21 I0) (= i21 i20) (= i2p1 i2p0) (= i21 i11) (>= x1 0) (<= a3p0 (- 0 1)) (>= N1 (+ i21 2)) (>= i31 (+ i21 2)) ) ");
  create_rule(res.trans,env,9,"x",1,"(and (= i3p1 i3p0) (= i31 i30) (= N1 N0) (= I1 N1) (= i1p1 i1p0) (= i11 i10) (= x1 a10) (= x1 x0) (= a3p0 a30) (= x1 a2p0) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,9,"x",6,"(and (= i3p1 i3p0) (= x1 x0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i31) (= i1p1 i1p0) (= x1 a10) (= i31 (+ i21 1)) (= a3p0 a30) (= x1 a2p0) (= i31 (+ I0 1)) (= i31 (+ i20 1)) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) (<= i31 i11) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,9,"x",15,"(and (= I1 (+ i11 1)) (= x1 x0) (= x1 a10) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i31 i30) (= i3p1 i3p0) (= x1 a2p0) (= a3p0 a30) (= i11 I0) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) (>= i21 (+ i11 1)) (>= N1 (+ i11 2)) (>= i31 (+ i11 2)) ) ");
  create_rule(res.trans,env,9,"x",10,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= x1 a10) (= x1 x0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 (+ i21 1)) (= a3p0 a30) (= x1 a2p0) (= i21 I0) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) (<= i21 (- i11 1)) (>= i31 (+ i21 2)) (>= N1 (+ i21 2)) ) ");
  create_rule(res.trans,env,9,"x",9,"(and (= i3p1 i3p0) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i31 i30) (= x1 a10) (= x1 x0) (= a3p0 a30) (= x1 a2p0) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) (<= I1 i11) (<= I1 (- N1 1)) (<= I1 (- i31 1)) (<= I1 i21) ) ");
  create_rule(res.trans,env,16,"x",9,"(and (= i1p1 i1p0) (= x1 x0) (= x1 a10) (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= a3p0 a30) (= I1 i21) (= a2p0 a20) (= i21 i20) (= i21 (+ I0 1)) (= i2p1 i2p0) (>= x1 0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= i21 i11) (>= N1 (+ i21 1)) (>= i31 (+ i21 1)) ) ");
  create_rule(res.trans,env,16,"x",17,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= x1 a10) (= x1 x0) (= N1 N0) (= i31 i30) (= I1 i31) (= i31 (+ i10 1)) (= a3p0 a30) (= a2p0 a20) (= i31 (+ I0 1)) (= i21 i20) (= i31 (+ i11 1)) (= i2p1 i2p0) (>= x1 0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 (- i21 1)) ) ");
  create_rule(res.trans,env,13,"x",8,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= i31 i30) (= N1 N0) (= i11 i10) (= x1 a10) (= x1 x0) (= a2p0 a20) (= I1 i21) (= i21 i20) (= i21 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (>= x1 0) (<= i21 i11) (>= N1 (+ i21 1)) ) ");
  create_rule(res.trans,env,13,"x",17,"(and (= I1 (+ i11 1)) (= i31 i30) (= i3p1 i3p0) (= x1 a10) (= x1 x0) (= N1 N0) (= i11 i10) (= i1p1 i1p0) (= i11 I0) (= a2p0 a20) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (>= x1 0) (>= N1 (+ i11 2)) (>= i21 (+ i11 2)) ) ");
  create_rule(res.trans,env,13,"x",13,"(and (= i31 i30) (= i3p1 i3p0) (= i1p1 i1p0) (= x1 a10) (= x1 x0) (= N1 N0) (= i11 i10) (= a2p0 a20) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (>= x1 0) (<= I1 i11) (<= I1 (- N1 1)) (<= I1 (- i21 1)) ) ");
  create_rule(res.trans,env,13,"x",12,"(and (= i3p1 i3p0) (= i1p1 i1p0) (= i31 i30) (= x1 a10) (= x1 x0) (= N1 N0) (= I1 i21) (= a2p0 a20) (= i21 (+ i10 1)) (= i21 i20) (= i21 (+ I0 1)) (= i2p1 i2p0) (= i21 (+ i11 1)) (>= x1 0) (>= a2p0 0) (>= N1 (+ i21 1)) ) ");
  create_rule(res.trans,env,9,"x",8,"(and (= i3p1 i3p0) (= x1 x0) (= x1 a10) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i31) (= x1 a2p0) (= a3p0 a30) (= i31 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) (<= i31 i11) (<= i31 (- N1 1)) (<= i31 i21) ) ");
  create_rule(res.trans,env,13,"x",1,"(and (= I1 N1) (= N1 N0) (= x1 a10) (= x1 x0) (= i3p1 i3p0) (= i31 i30) (= i11 i10) (= i1p1 i1p0) (= a2p0 a20) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (>= x1 0) ) ");
  create_rule(res.trans,env,16,"x",13,"(and (= i3p1 i3p0) (= x1 x0) (= x1 a10) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i31) (= a2p0 a20) (= a3p0 a30) (= i31 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (>= x1 0) (<= a3p0 (- 0 1)) (<= i31 i11) (<= i31 (- N1 1)) (<= i31 (- i21 1)) ) ");
  create_rule(res.trans,env,6,"x",1,"(and (= i31 i30) (= i1p1 i1p0) (= i3p1 i3p0) (= I1 N1) (= N1 N0) (= i11 i10) (= x1 x0) (= x1 a10) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= x1 0) ) ");
  create_rule(res.trans,env,16,"x",12,"(and (= i3p1 i3p0) (= i1p1 i1p0) (= x1 x0) (= N1 N0) (= i31 i30) (= I1 i31) (= i31 i21) (= x1 a10) (= i31 (+ i10 1)) (= a3p0 a30) (= i31 i20) (= a2p0 a20) (= i31 (+ I0 1)) (= i31 (+ i11 1)) (= i2p1 i2p0) (>= x1 0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,16,"x",8,"(and (= i3p1 i3p0) (= i1p1 i1p0) (= x1 a10) (= x1 x0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i31) (= i31 i21) (= a3p0 a30) (= a2p0 a20) (= i31 i20) (= i31 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (>= x1 0) (<= a3p0 (- 0 1)) (<= i31 i11) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,16,"x",1,"(and (= i1p1 i1p0) (= x1 a10) (= x1 x0) (= i3p1 i3p0) (= N1 N0) (= I1 N1) (= i11 i10) (= i31 i30) (= a2p0 a20) (= a3p0 a30) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (>= x1 0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,16,"x",18,"(and (= I1 (+ i11 1)) (= i1p1 i1p0) (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= x1 a10) (= x1 x0) (= a3p0 a30) (= a2p0 a20) (= i11 I0) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (>= x1 0) (<= a3p0 (- 0 1)) (>= N1 (+ i11 2)) (>= i31 (+ i11 2)) (>= i21 (+ i11 2)) ) ");
  create_rule(res.trans,env,16,"x",16,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= x1 a10) (= x1 x0) (= N1 N0) (= i11 i10) (= i31 i30) (= a3p0 a30) (= a2p0 a20) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (>= x1 0) (<= a3p0 (- 0 1)) (<= I1 i11) (<= I1 (- i31 1)) (<= I1 (- N1 1)) (<= I1 (- i21 1)) ) ");
  create_rule(res.trans,env,16,"x",15,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= N1 N0) (= i31 i30) (= x1 a10) (= x1 x0) (= a3p0 a30) (= a2p0 a20) (= I1 i21) (= i21 (+ i10 1)) (= i21 i20) (= i21 (+ I0 1)) (= i2p1 i2p0) (= i21 (+ i11 1)) (>= a2p0 0) (>= x1 0) (<= a3p0 (- 0 1)) (>= N1 (+ i21 1)) (>= i31 (+ i21 1)) ) ");
  create_rule(res.trans,env,14,"x",7,"(and (= i11 i10) (= N1 N0) (= i31 i30) (= I1 i31) (= i3p1 i3p0) (= i1p1 i1p0) (= x1 x0) (= a3p0 a30) (= i31 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,14,"x",1,"(and (= i31 i30) (= i1p1 i1p0) (= I1 N1) (= N1 N0) (= i11 i10) (= i3p1 i3p0) (= x1 x0) (= a3p0 a30) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,14,"x",14,"(and (= i31 i30) (= N1 N0) (= i11 i10) (= i1p1 i1p0) (= i3p1 i3p0) (= x1 x0) (= a3p0 a30) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= I1 (- i31 1)) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,17,"x",12,"(and (= i1p1 i1p0) (= i31 i30) (= i11 i10) (= x1 x0) (= N1 N0) (= i3p1 i3p0) (= a2p0 a20) (= I1 i21) (= i21 i20) (= i21 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (>= N1 (+ i21 1)) ) ");
  create_rule(res.trans,env,17,"x",17,"(and (= i11 i10) (= i1p1 i1p0) (= N1 N0) (= i3p1 i3p0) (= i31 i30) (= x1 x0) (= a2p0 a20) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= I1 (- N1 1)) (<= I1 (- i21 1)) ) ");
  create_rule(res.trans,env,17,"x",1,"(and (= i31 i30) (= i3p1 i3p0) (= i11 i10) (= i1p1 i1p0) (= x1 x0) (= I1 N1) (= N1 N0) (= a2p0 a20) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) ) ");
  create_rule(res.trans,env,15,"x",12,"(and (= i11 i10) (= i1p1 i1p0) (= N1 N0) (= i31 i30) (= I1 i31) (= x1 x0) (= i3p1 i3p0) (= x1 a2p0) (= a3p0 a30) (= i31 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 i21) ) ");
  create_rule(res.trans,env,15,"x",1,"(and (= i3p1 i3p0) (= x1 x0) (= i1p1 i1p0) (= N1 N0) (= I1 N1) (= i11 i10) (= i31 i30) (= x1 a2p0) (= a3p0 a30) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,15,"x",14,"(and (= x1 x0) (= N1 N0) (= i31 i30) (= i11 i10) (= i3p1 i3p0) (= i1p1 i1p0) (= I1 (+ i21 1)) (= x1 a2p0) (= a3p0 a30) (= i21 I0) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (>= N1 (+ i21 2)) (>= i31 (+ i21 2)) ) ");
  create_rule(res.trans,env,15,"x",15,"(and (= i3p1 i3p0) (= x1 x0) (= N1 N0) (= i31 i30) (= i11 i10) (= i1p1 i1p0) (= a3p0 a30) (= x1 a2p0) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= I1 (- N1 1)) (<= I1 (- i31 1)) (<= I1 i21) ) ");
  create_rule(res.trans,env,15,"x",7,"(and (= i1p1 i1p0) (= i11 i10) (= i3p1 i3p0) (= x1 x0) (= N1 N0) (= i31 i30) (= I1 i31) (= i31 (+ i21 1)) (= x1 a2p0) (= a3p0 a30) (= i31 (+ I0 1)) (= i31 (+ i20 1)) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,18,"x",17,"(and (= N1 N0) (= i31 i30) (= I1 i31) (= x1 x0) (= i3p1 i3p0) (= i1p1 i1p0) (= i11 i10) (= a3p0 a30) (= a2p0 a20) (= i31 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 (- i21 1)) ) ");
  create_rule(res.trans,env,18,"x",15,"(and (= x1 x0) (= i3p1 i3p0) (= i1p1 i1p0) (= i11 i10) (= N1 N0) (= i31 i30) (= a2p0 a20) (= a3p0 a30) (= I1 i21) (= i21 i20) (= i21 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= i31 (+ i21 1)) (>= N1 (+ i21 1)) ) ");
  create_rule(res.trans,env,18,"x",1,"(and (= x1 x0) (= i11 i10) (= i1p1 i1p0) (= i31 i30) (= I1 N1) (= N1 N0) (= i3p1 i3p0) (= a2p0 a20) (= a3p0 a30) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,18,"x",12,"(and (= x1 x0) (= i11 i10) (= N1 N0) (= i31 i30) (= I1 i31) (= i31 i21) (= i3p1 i3p0) (= i1p1 i1p0) (= a3p0 a30) (= i31 i20) (= a2p0 a20) (= i31 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,18,"x",18,"(and (= i11 i10) (= i1p1 i1p0) (= N1 N0) (= i31 i30) (= x1 x0) (= i3p1 i3p0) (= a3p0 a30) (= a2p0 a20) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= I1 (- N1 1)) (<= I1 (- i31 1)) (<= I1 (- i21 1)) ) ");
  create_rule(res.trans,env,10,"x",6,"(and (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i31) (= x1 a10) (= x1 x0) (= i1p1 i1p0) (= a3p0 a30) (= i31 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) (<= i31 i11) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,10,"x",1,"(and (= i11 i10) (= i1p1 i1p0) (= N1 N0) (= I1 N1) (= x1 a10) (= x1 x0) (= i31 i30) (= i3p1 i3p0) (= a3p0 a30) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,10,"x",14,"(and (= I1 (+ i11 1)) (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= i1p1 i1p0) (= x1 a10) (= x1 x0) (= a3p0 a30) (= i11 I0) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (<= a3p0 (- 0 1)) (>= N1 (+ i11 2)) (>= i31 (+ i11 2)) ) ");
  create_rule(res.trans,env,0,"x",6,"(and (= I1 1) (= i2p1 1) (= i3p0 1) (= i30 1) (= i10 1) (= I0 0) (= i20 0) (= i21 0) (= i3p1 1) (= i11 1) (= x1 x0) (= N1 N0) (= i31 1) (= i1p1 2) (= a3p0 a30) (= x1 a2p0) (= i2p0 1) (= i1p0 2) (<= a3p0 (- 0 1)) (>= N1 3) ) ");
  create_rule(res.trans,env,0,"x",2,"(and (= I1 1) (= I0 0) (= x1 x0) (= i11 i10) (= N1 N0) (= i20 1) (= i1p1 i1p0) (= i31 i30) (= i3p1 i3p0) (= a3p0 a30) (= a2p0 a20) (= i3p0 i30) (= i30 (+ (- 0 i20) i10)) (= i2p0 (+ i20 1)) (= i21 i20) (= i2p1 i2p0) (= i1p0 (+ i10 1)) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= i2p0 1) (>= i3p0 0) (>= N0 2) (<= i1p0 (- N0 1)) (>= i30 2) (<= i3p0 (- N0 1)) (>= i10 2) (>= i1p0 1) (<= i2p0 (- N0 1)) ) ");
  create_rule(res.trans,env,19,"x",13,"(and (= x1 x0) (= i1p1 i1p0) (= i3p1 i3p0) (= N1 N0) (= i31 i10) (= i31 i30) (= I1 i31) (= a3p0 a30) (= a2p0 a20) (= i31 (+ I0 1)) (= i21 i20) (= i31 i11) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 (- i21 1)) ) ");
  create_rule(res.trans,env,19,"x",16,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= x1 x0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i11) (= a2p0 a20) (= a3p0 a30) (= i11 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= N1 (+ i11 1)) (>= i31 (+ i11 1)) (>= i21 (+ i11 1)) ) ");
  create_rule(res.trans,env,0,"x",11,"(and (= I1 1) (= i30 1) (= I0 0) (= i1p1 i1p0) (= i11 i10) (= N1 N0) (= i3p1 i3p0) (= i31 i30) (= x1 x0) (= a3p0 a30) (= i3p0 i30) (= a2p0 a20) (= i2p0 (+ i20 1)) (= i30 (+ (- 0 i20) i10)) (= i21 i20) (= i2p1 i2p0) (= i1p0 (+ i10 1)) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= i2p0 1) (>= i20 2) (>= i3p0 0) (<= i1p0 (- N0 1)) (>= N0 2) (<= i3p0 (- N0 1)) (>= i10 2) (>= i1p0 1) (<= i2p0 (- N0 1)) ) ");
  create_rule(res.trans,env,0,"x",3,"(and (= I1 1) (= i30 1) (= I0 0) (= i1p1 i1p0) (= i11 i10) (= N1 N0) (= i20 1) (= i31 i30) (= i3p1 i3p0) (= x1 x0) (= a3p0 a30) (= a2p0 a20) (= i3p0 i30) (= i2p0 (+ i20 1)) (= i21 i20) (= i2p1 i2p0) (= i1p0 (+ i10 1)) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= i2p0 1) (>= i3p0 0) (>= N0 2) (<= i1p0 (- N0 1)) (<= i3p0 (- N0 1)) (>= i30 (+ (- 0 i20) i10)) (>= i10 2) (>= i1p0 1) (<= i2p0 (- N0 1)) ) ");
  create_rule(res.trans,env,0,"x",7,"(and (= I1 1) (= i10 0) (= I0 0) (= x1 x0) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i3p1 i3p0) (= i31 i30) (= x1 a10) (= i20 0) (= x1 a2p0) (= i21 i20) (= i2p1 i2p0) (>= x1 0) (<= i30 0) (>= i2p0 1) (>= i3p0 0) (<= i3p0 i30) (<= i1p0 (- N0 1)) (>= N0 2) (<= i3p0 (- N0 1)) (>= i30 (+ (- 0 i20) i10)) (<= i2p0 (+ i20 1)) (<= i1p0 (+ i10 1)) (>= i1p0 1) (<= i2p0 (- N0 1)) ) ");
  create_rule(res.trans,env,0,"x",5,"(and (= I1 1) (= I0 0) (= x1 x0) (= i1p1 i1p0) (= i11 i10) (= N1 N0) (= i31 i30) (= i3p1 i3p0) (= i20 0) (= x1 a2p0) (= i3p0 i30) (= a3p0 a30) (= i30 (+ (- 0 i20) i10)) (= i21 i20) (= i2p1 i2p0) (= i1p0 (+ i10 1)) (<= a3p0 (- 0 1)) (>= i2p0 1) (>= i3p0 0) (<= i1p0 (- N0 1)) (>= N0 2) (>= i30 2) (<= i3p0 (- N0 1)) (<= i2p0 (+ i20 1)) (>= i10 2) (>= i1p0 1) (<= i2p0 (- N0 1)) ) ");
  create_rule(res.trans,env,19,"x",9,"(and (= i1p1 i1p0) (= i3p1 i3p0) (= N1 N0) (= i31 i30) (= x1 x0) (= a3p0 a30) (= i21 i10) (= I1 i21) (= a2p0 a20) (= i21 i20) (= i21 (+ I0 1)) (= i2p1 i2p0) (= i21 i11) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= N1 (+ i21 1)) (>= i31 (+ i21 1)) ) ");
  create_rule(res.trans,env,19,"x",2,"(and (= i1p1 i1p0) (= x1 x0) (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= a2p0 a20) (= I1 i21) (= a3p0 a30) (= i21 i20) (= i21 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= N1 (+ i21 1)) (<= i21 (- i11 1)) (>= i31 (+ i21 1)) ) ");
  create_rule(res.trans,env,8,"x",8,"(and (= i3p1 i3p0) (= i31 i30) (= x1 a10) (= x1 x0) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= x1 a2p0) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= x1 0) (<= I1 i11) (<= I1 (- N1 1)) (<= I1 i21) ) ");
  create_rule(res.trans,env,19,"x",19,"(and (= i3p1 i3p0) (= x1 x0) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i31 i30) (= a3p0 a30) (= a2p0 a20) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= I1 (- N1 1)) (<= I1 (- i11 1)) (<= I1 (- i31 1)) (<= I1 (- i21 1)) ) ");
  create_rule(res.trans,env,19,"x",3,"(and (= i1p1 i1p0) (= x1 x0) (= i3p1 i3p0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i31) (= i31 i21) (= a3p0 a30) (= i31 i20) (= a2p0 a20) (= i31 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 (- i11 1)) ) ");
  create_rule(res.trans,env,19,"x",1,"(and (= i3p1 i3p0) (= N1 N0) (= I1 N1) (= i1p1 i1p0) (= x1 x0) (= i11 i10) (= i31 i30) (= a3p0 a30) (= a2p0 a20) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,19,"x",11,"(and (= x1 x0) (= i3p1 i3p0) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i31 i30) (= I1 i31) (= a2p0 a20) (= a3p0 a30) (= i31 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) (<= i31 (- i11 1)) (<= i31 (- i21 1)) ) ");
  create_rule(res.trans,env,19,"x",8,"(and (= i1p1 i1p0) (= x1 x0) (= i3p1 i3p0) (= N1 N0) (= i31 i10) (= i31 i30) (= I1 i31) (= i31 i21) (= a3p0 a30) (= i31 i20) (= a2p0 a20) (= i31 (+ I0 1)) (= i31 i11) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= i31 (- N1 1)) ) ");
  create_rule(res.trans,env,0,"x",19,"(and (= I1 1) (= I0 0) (= i1p1 i1p0) (= i11 i10) (= N1 N0) (= i31 i30) (= i3p1 i3p0) (= x1 x0) (= a2p0 a20) (= a3p0 a30) (= i3p0 i30) (= i2p0 (+ i20 1)) (= i30 (+ (- 0 i20) i10)) (= i21 i20) (= i2p1 i2p0) (= i1p0 (+ i10 1)) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= i2p0 1) (>= i20 2) (>= i3p0 0) (<= i1p0 (- N0 1)) (>= N0 2) (>= i30 2) (<= i3p0 (- N0 1)) (>= i10 2) (>= i1p0 1) (<= i2p0 (- N0 1)) ) ");
  create_rule(res.trans,env,0,"x",8,"(and (= I1 1) (= i10 1) (= I0 0) (= i20 1) (= N1 N0) (= i1p1 i1p0) (= i11 i10) (= x1 x0) (= i3p1 i3p0) (= i31 i30) (= a2p0 a20) (= i2p0 (+ i20 1)) (= i21 i20) (= i2p1 i2p0) (= i1p0 (+ i10 1)) (<= i30 0) (>= a2p0 0) (>= i2p0 1) (>= i3p0 0) (<= i3p0 i30) (<= i1p0 (- N0 1)) (>= N0 2) (<= i3p0 (- N0 1)) (>= i30 (+ (- 0 i20) i10)) (>= i1p0 1) (<= i2p0 (- N0 1)) ) ");
  create_rule(res.trans,env,0,"x",11,"(and (= I1 1) (= I0 0) (= x1 x0) (= i1p1 i1p0) (= i11 i10) (= N1 N0) (= i31 i30) (= i3p1 i3p0) (= a2p0 a20) (= i2p0 (+ i20 1)) (= i30 (+ (- 0 i20) i10)) (= i21 i20) (= i2p1 i2p0) (= i1p0 (+ i10 1)) (<= i30 0) (>= a2p0 0) (>= i2p0 1) (>= i20 2) (>= i3p0 0) (<= i3p0 i30) (<= i1p0 (- N0 1)) (>= N0 2) (<= i3p0 (- N0 1)) (>= i10 2) (>= i1p0 1) (<= i2p0 (- N0 1)) ) ");

  std::vector<automaton> res_v;		
  res_v.push_back(res);
  return res_v;
}

automaton get_rhs_automaton_concrete(msat_env env) {
  automaton res;
  /* alphabet */
  res.alphabet.insert("x");
  /* variables */
  res.vars.insert("a2p");
  res.vars.insert("a3p");
  res.vars.insert("N");
  res.vars.insert("I");
  res.vars.insert("i3p");
  res.vars.insert("i2p");
  res.vars.insert("a1");
  res.vars.insert("a2");
  res.vars.insert("i1p");
  res.vars.insert("a3");
  res.vars.insert("i3");
  res.vars.insert("i2");
  res.vars.insert("x");
  res.vars.insert("i1");
  create_msat_variables(env,res.vars,msat_get_integer_type(env));
  /* init states */
  res.init_states.insert(0);
  /* final states */
  res.final_states.insert(1);
  /* create rules */
  create_rule(res.trans,env,2,"x",2,"(and (= i31 i30) (= x1 x0) (= i1p1 i1p0) (= N1 N0) (= i3p1 i3p0) (= i11 i10) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (<= I1 (- N1 1)) (<= I1 (- i3p1 1)) (<= I1 (- i2p1 1)) ) ");
  create_rule(res.trans,env,2,"x",3,"(and (= i1p1 i1p0) (= i31 i30) (= i11 i10) (= N1 N0) (= i3p1 i3p0) (= x1 x0) (= I1 i2p1) (= i21 i20) (= i2p1 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= N1 (+ i2p1 1)) (<= i2p1 (- i3p1 1)) ) ");
  create_rule(res.trans,env,4,"x",1,"(and (= i3p1 i3p0) (= i11 i10) (= i31 i30) (= x1 x0) (= I1 N1) (= N1 N0) (= i1p1 i1p0) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) ) ");
  create_rule(res.trans,env,2,"x",1,"(and (= i3p1 i3p0) (= x1 x0) (= i11 i10) (= i1p1 i1p0) (= I1 N1) (= N1 N0) (= i31 i30) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,5,"x",4,"(and (= i1p1 i1p0) (= x1 x0) (= i3p1 i3p0) (= i31 i30) (= i11 i10) (= N1 N0) (= I1 i2p1) (= i21 i20) (= i2p1 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (>= N1 (+ i2p1 1)) ) ");
  create_rule(res.trans,env,4,"x",4,"(and (= i1p1 i1p0) (= N1 N0) (= x1 x0) (= i11 i10) (= i3p1 i3p0) (= i31 i30) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,5,"x",1,"(and (= i3p1 i3p0) (= i11 i10) (= i31 i30) (= i1p1 i1p0) (= x1 x0) (= I1 N1) (= N1 N0) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) ) ");
  create_rule(res.trans,env,5,"x",5,"(and (= i3p1 i3p0) (= x1 x0) (= N1 N0) (= i11 i10) (= i1p1 i1p0) (= i31 i30) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (>= a2p0 0) (<= I1 (- N1 1)) (<= I1 (- i2p1 1)) ) ");
  create_rule(res.trans,env,3,"x",4,"(and (= i1p1 i1p0) (= I1 i3p1) (= i3p1 i3p0) (= N1 N0) (= i31 i30) (= x1 x0) (= i11 i10) (= i3p1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (>= N1 (+ i3p1 1)) ) ");
  create_rule(res.trans,env,3,"x",1,"(and (= x1 x0) (= i11 i10) (= i1p1 i1p0) (= I1 N1) (= N1 N0) (= i3p1 i3p0) (= i31 i30) (= N1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) ) ");
  create_rule(res.trans,env,3,"x",3,"(and (= i11 i10) (= i1p1 i1p0) (= x1 x0) (= i31 i30) (= i3p1 i3p0) (= N1 N0) (= i21 i20) (= I1 (+ I0 1)) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (<= I1 (- i3p1 1)) (<= I1 (- N1 1)) ) ");
  create_rule(res.trans,env,2,"x",5,"(and (= i11 i10) (= i1p1 i1p0) (= N1 N0) (= i3p1 i3p0) (= I1 i3p1) (= i31 i30) (= x1 x0) (= i3p1 (+ I0 1)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= N1 (+ i3p1 1)) (>= i2p1 (+ i3p1 1)) ) ");
  create_rule(res.trans,env,2,"x",4,"(and (= x1 x0) (= i1p1 i1p0) (= i11 i10) (= N1 N0) (= i3p1 i3p0) (= I1 i3p1) (= i2p1 i3p1) (= i31 i30) (= i3p1 (+ I0 1)) (= i21 i20) (= i3p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= N1 (+ i3p1 1)) ) ");
  create_rule(res.trans,env,0,"x",4,"(and (= I1 1) (= i3p0 1) (= I0 0) (= N1 N0) (= i31 i30) (= i11 i10) (= x1 x0) (= i3p1 i3p0) (= i1p1 i1p0) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (= i2p0 1) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= N1 2) ) ");
  create_rule(res.trans,env,0,"x",4,"(and (= I1 1) (= i3p0 1) (= I0 0) (= i3p1 i3p0) (= i1p1 i1p0) (= i11 i10) (= x1 x0) (= i31 i30) (= N1 N0) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (>= N1 2) (<= i2p0 0) ) ");
  create_rule(res.trans,env,0,"x",1,"(and (= I1 1) (= N0 1) (= I0 0) (= i11 i10) (= x1 x0) (= i3p1 i3p0) (= i1p1 i1p0) (= i31 i30) (= N1 1) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (<= i3p0 0) (>= a2p0 0) (>= i2p0 1) ) ");
  create_rule(res.trans,env,0,"x",1,"(and (= N0 1) (= I1 1) (= I0 0) (= x1 x0) (= i3p1 i3p0) (= i1p1 i1p0) (= N1 1) (= i31 i30) (= i11 i10) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (>= i3p0 1) (<= i2p0 0) ) ");
  create_rule(res.trans,env,0,"x",5,"(and (= I1 1) (= i3p0 1) (= I0 0) (= i11 i10) (= x1 x0) (= i31 i30) (= N1 N0) (= i3p1 i3p0) (= i1p1 i1p0) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= N1 2) (>= i2p0 2) ) ");
  create_rule(res.trans,env,0,"x",4,"(and (= I1 1) (= I0 0) (= i3p1 i3p0) (= i1p1 i1p0) (= x1 x0) (= N1 N0) (= i31 i30) (= i11 i10) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (= i2p0 1) (<= i3p0 0) (>= a2p0 0) (>= N1 2) ) ");
  create_rule(res.trans,env,0,"x",4,"(and (= I1 1) (= I0 0) (= i11 i10) (= i31 i30) (= N1 N0) (= x1 x0) (= i3p1 i3p0) (= i1p1 i1p0) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (<= i3p0 0) (>= N1 2) (<= i2p0 0) ) ");
  create_rule(res.trans,env,0,"x",1,"(and (= N0 1) (= I1 1) (= I0 0) (= i11 i10) (= i31 i30) (= N1 1) (= i3p1 i3p0) (= i1p1 i1p0) (= x1 x0) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (<= i3p0 0) (<= i2p0 0) ) ");
  create_rule(res.trans,env,0,"x",3,"(and (= I1 1) (= I0 0) (= x1 x0) (= i3p1 i3p0) (= i1p1 i1p0) (= N1 N0) (= i11 i10) (= i31 i30) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (= i2p0 1) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= N1 2) (>= i3p0 2) ) ");
  create_rule(res.trans,env,0,"x",2,"(and (= I1 1) (= I0 0) (= N1 N0) (= i31 i30) (= i3p1 i3p0) (= i1p1 i1p0) (= x1 x0) (= i11 i10) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= N1 2) (>= i2p0 2) (>= i3p0 2) ) ");
  create_rule(res.trans,env,0,"x",1,"(and (= I1 1) (= N0 1) (= I0 0) (= i31 i30) (= x1 x0) (= i11 i10) (= i3p1 i3p0) (= i1p1 i1p0) (= N1 1) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= a3p0 (- 0 1)) (>= i2p0 1) (>= i3p0 1) ) ");
  create_rule(res.trans,env,0,"x",3,"(and (= I1 1) (= I0 0) (= i31 i30) (= i11 i10) (= x1 x0) (= i3p1 i3p0) (= i1p1 i1p0) (= N1 N0) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (<= a3p0 (- 0 1)) (>= N1 2) (>= i3p0 2) (<= i2p0 0) ) ");
  create_rule(res.trans,env,0,"x",5,"(and (= I1 1) (= I0 0) (= x1 x0) (= N1 N0) (= i11 i10) (= i3p1 i3p0) (= i1p1 i1p0) (= i31 i30) (= i3p0 (+ (- 0 i2p0) i1p0)) (= i21 i20) (= i2p1 i2p0) (>= a2p0 0) (<= i3p0 0) (>= N1 2) (>= i2p0 2) ) ");
  return res;
}
