#include "main.h"
#include "create_automata.h"

/**
 * 2015 manually created from synlifo.vhd
 * Model synlifo
 *   init states:   init
 *   final states:  empty0full1
 *   input symbols: rd,wr (and complements: !rd,!wr)
 *   counters:      addr,max
 */

std::vector<automaton> get_lhs_automaton_concrete(msat_env env){
	automaton res;
	/* alphabet */
	res.alphabet.insert("w");
	res.alphabet.insert("r");
	res.alphabet.insert("rw");
	res.alphabet.insert("n");
	/* variables */
	res.vars.insert("addr");
	res.vars.insert("max");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* states */
	int init=0;
	int empty0full0=1;
	int empty1full0=2;
	int empty0full1=3;
	/* init states */
	res.init_states.insert(init);
	/* final states */
	res.final_states.insert(empty0full1);

	create_rule(res.trans,env,init,"n",empty1full0,"(and  (= 0 addr1) (> max1 1) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"n",empty0full0,"(and  (< 0 addr0) (< addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"n",empty1full0,"(and  (= addr0 0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"n",empty0full1,"(and  (= addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"n",empty0full0,"(and  (< 0 addr0) (< addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"n",empty1full0,"(and  (= addr0 0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"n",empty0full1,"(and  (= addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"n",empty0full0,"(and  (< 0 addr0) (< addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"n",empty1full0,"(and  (= addr0 0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"n",empty0full1,"(and  (= addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"r",empty0full0,"(and  (not (= addr0 1)) (= addr0 (- addr1 1)) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"r",empty1full0,"(and  (= 1 addr0) (= addr0 (- addr1 1)) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"r",empty0full0,"(and  (< 0 addr0) (< addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"r",empty1full0,"(and  (= addr0 0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"r",empty0full1,"(and  (= addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"r",empty0full0,"(and  (not (= addr0 1)) (= addr0 (- addr1 1)) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"r",empty1full0,"(and  (= 1 addr0) (= addr0 (- addr1 1)) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"w",empty0full0,"(and  (< 0 addr0) (< addr0 (- max0 1)) (= addr0 (+ addr1 1)) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"w",empty1full0,"(and  (= addr0 0) (= addr0 (+ addr1 1)) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"w",empty0full1,"(and  (>= addr0 (- max0 1)) (= addr0 (+ addr1 1)) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"w",empty0full0,"(and  (< 0 addr0) (< addr0 (- max0 1)) (= addr0 (+ addr1 1)) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"w",empty1full0,"(and  (= addr0 0) (= addr0 (+ addr1 1)) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"w",empty0full1,"(and  (>= addr0 (- max0 1)) (= addr0 (+ addr1 1)) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"w",empty0full0,"(and  (< 0 addr0) (< addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"w",empty1full0,"(and  (= addr0 0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"w",empty0full1,"(and  (= addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"rw",empty0full0,"(and  (< 0 addr0) (< addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"rw",empty1full0,"(and  (= addr0 0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full0,"rw",empty0full1,"(and  (= addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"rw",empty0full0,"(and  (< 0 addr0) (< addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"rw",empty1full0,"(and  (= addr0 0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty1full0,"rw",empty0full1,"(and  (= addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"rw",empty0full0,"(and  (< 0 addr0) (< addr0 max0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"rw",empty1full0,"(and  (= addr0 0) (= addr0 addr1) (= max0 max1))");
	create_rule(res.trans,env,empty0full1,"rw",empty0full1,"(and  (= addr0 max0) (= addr0 addr1) (= max0 max1))");


	add_invariant(res,env,empty1full0,"(and (<= addr0 1) (>= addr0 0))");
	std::vector<automaton> res_v;		
	res_v.push_back(res);
	return res_v;
}


/**
 * 2015 manually created from synlifo.vhd
 * Specification of synlifo (`check-full-signal' property)
 *   init states:   accept0
 *   final states:  accept1
 *   input symbols:
 *   counters:      addr
 */
automaton get_rhs_automaton_concrete(msat_env env){
	automaton res;
	/* alphabet */
	res.alphabet.insert("w");
	res.alphabet.insert("r");
	res.alphabet.insert("rw");
	res.alphabet.insert("n");

	/* variables */
	res.vars.insert("addr");
	res.vars.insert("max");

	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* states */
	int accept0=0;
	int accept1=1;

	/* init states */
	res.init_states.insert(accept0);
	/* final states */
	res.final_states.insert(accept1);
	/* create rules */

	create_rule(res.trans,env,accept0,"r",accept1,"(= addr1 max0)");
	create_rule(res.trans,env,accept0,"w",accept1,"(= addr1 max0)");
	create_rule(res.trans,env,accept0,"rw",accept1,"(= addr1 max0)");
	create_rule(res.trans,env,accept0,"n",accept1,"(= addr1 max0)");
	create_rule(res.trans,env,accept0,"r",accept0,"(< addr1 max0)");
	create_rule(res.trans,env,accept0,"w",accept0,"(< addr1 max0)");
	create_rule(res.trans,env,accept0,"rw",accept0,"(< addr1 max0)");
	create_rule(res.trans,env,accept0,"n",accept0,"(< addr1 max0)");
	create_rule(res.trans,env,accept1,"r",accept1,"(= addr1 max0)");
	create_rule(res.trans,env,accept1,"w",accept1,"(= addr1 max0)");
	create_rule(res.trans,env,accept1,"rw",accept1,"(= addr1 max0)");
	create_rule(res.trans,env,accept1,"n",accept1,"(= addr1 max0)");
	create_rule(res.trans,env,accept1,"r",accept0,"(< addr1 max0)");
	create_rule(res.trans,env,accept1,"w",accept0,"(< addr1 max0)");
	create_rule(res.trans,env,accept1,"rw",accept0,"(< addr1 max0)");
	create_rule(res.trans,env,accept1,"n",accept0,"(< addr1 max0)");
	return res;
}
