#include "main.h"
#include "create_automata.h"


std::vector<automaton> get_lhs_automaton_concrete(msat_env env){
	automaton res;
	/* alphabet */
	res.alphabet.insert("a");
	res.alphabet.insert("b");
	/* variables */
	res.vars.insert("a");
	res.vars.insert("m");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* init states */
	res.init_states.insert(0);
	/* final states */
	res.final_states.insert(1);
	/* create rules */
	create_rule(res.trans,env,0,"a",1,"(and (> m0 1) (= m1 m0) (= a1 0))");
	create_rule(res.trans,env,1,"a",1,"(and (< a0 (- m0 1)) (= a1 (+ a0 1)) (= m0 m1))");
	create_rule(res.trans,env,1,"b",1,"(and (= a0 (- m0 1)) (= a1 0) (= m0 m1))");
	std::vector<automaton> res_v;		
	res_v.push_back(res);
	return res_v;

}


automaton get_rhs_automaton_concrete(msat_env env){
	automaton res;
	/* alphabet */
	res.alphabet.insert("a");
	/* variables */
	res.vars.insert("a");
	res.vars.insert("m");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* init states */
	res.init_states.insert(0);
	/* final states */
	res.final_states.insert(0);
	/* create rules */
	create_rule(res.trans,env,0,"a",0,"(< a1 m1)");
	create_rule(res.trans,env,0,"b",0,"(< a1 m1)");


	return res;

}
