#include "main.h"
#include "create_automata.h"

#define __INIT "(and (= 0 t1) (< 0 T1) (< 0 N1) (= 0 sdata1) (= 0 bdata1) (= 0 sbit1) (= 0 bbit1) (= 0 sack1) (= 0 back1) (= 0 rdata1) (= 0 rtbit1) (= 0 rbit1) (= 0 x1) (= 0 y1))"

#define __S_01 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (= sdata1 (+ sdata0 1)) (= bdata0 bdata1) (= sbit0 sbit1) (= bbit0 bbit1) (= sack0 sack1) (= back0 back1) (= rdata0 rdata1) (= rtbit0 rtbit1) (= rbit0 rbit1) (= x1 x0) (= y1 y0))"

#define __S_12 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (or (and (< N0 sdata0) (= sdata1 (+ sdata0 1))) (and (<= sdata0 N0) (= sdata1 sdata0))) (= bdata0 bdata1) (= sbit0 sbit1) (= bbit0 bbit1) (= sack0 sack1) (= back0 back1) (= rdata0 rdata1) (= rtbit0 rtbit1) (= rbit0 rbit1) (= x1 x0) (= y1 y0))"

#define __S_23__B_02 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (= sdata1 sdata0) (= bdata1 sdata0) (= sbit0 sbit1) (= bbit1 sbit0) (= sack0 sack1) (= back0 back1) (= rdata0 rdata1) (= rtbit0 rtbit1) (= rbit0 rbit1) (= x1 t0) (<= t1 (+ x1 T0)) (= y1 t0))"

#define __S_32 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (= sdata1 sdata0) (= bdata1 sdata0) (= sbit0 sbit1) (= bbit0 bbit1) (= sack0 sack1) (= back0 back1) (= rdata0 rdata1) (= rtbit0 rtbit1) (= rbit0 rbit1) (= x0 T0) (= x1 x0) (= y1 y0))"

#define __B_20 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (= sdata1 sdata0) (= bdata1 sdata0) (= sbit0 sbit1) (= bbit0 bbit1) (= sack0 sack1) (= back0 back1) (= rdata0 rdata1) (= rtbit0 rtbit1) (= rbit0 rbit1) (< x0 T0) (= x1 x0) (= y1 y0))"

#define __B_10 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (= sdata1 sdata0) (= bdata1 sdata0) (= sbit0 sbit1) (= bbit0 bbit1) (= sack0 sack1) (= back0 back1) (= rdata0 rdata1) (= rtbit0 rtbit1) (= rbit0 rbit1) (< x0 T0) (= x1 x0) (= y1 y0))"

#define __B_20__R_01 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (= sdata1 sdata0) (= bdata1 bdata0) (= sbit0 sbit1) (= bbit0 bbit1) (= sack0 sack1) (= back0 back1) (= rdata1 bdata0) (= rtbit1 bbit0) (= rbit0 rbit1) (= x1 x0) (< y0 T0) (= y1 y0))"

#define __B_01__R_10 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (= sdata1 sdata0) (= bdata1 bdata0) (= sbit0 sbit1) (= bbit0 bbit1) (= sack0 sack1) (= back1 rbit0) (= rdata1 rdata0) (= rbit0 rbit1) (= x1 x0) (= y1 t0))"

#define __S_34__B_10 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (= sdata1 sdata0) (= bdata1 bdata0) (= sbit0 sbit1) (= bbit0 bbit1) (= sack1 back0) (= back0 back1) (= rdata0 rdata1) (= rtbit0 rtbit1) (= rbit0 rbit1) (= x1 x0) (< y0 T0) (= y1 y0))"

#define __S_42 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (= sdata1 sdata0) (= bdata1 sdata0) (= sbit0 sbit1) (= bbit0 bbit1) (not (= sack0 sbit0)) (= sack0 sack1) (= back0 back1) (= rdata0 rdata1) (= rtbit0 rtbit1) (= rbit0 rbit1) (= x1 x0) (= y1 y0))"


/*
 * IMPORTANT:
 * changing (= sbit1 (- 1 sbit0)) with (= sbit1 (- 0 sbit0)) below makes the inclusion hold.
 */

#define __S_40 "(and (<= t0 t1) (= T0 T1) (= N0 N1) (= sdata1 sdata0) (= bdata1 sdata0) (= sbit1 (- 1 sbit0)) (= bbit0 bbit1) (= sack0 sbit0) (= sack0 sack1) (= back0 back1) (= rdata0 rdata1) (= rtbit0 rtbit1) (= rbit0 rbit1) (= x1 x0) (= y1 y0))"

std::vector<automaton> get_lhs_automaton_concrete(msat_env env) {
  automaton res;
  /* alphabet */
  res.alphabet.insert("tau");
  res.alphabet.insert("send_data");
  res.alphabet.insert("rec_data");
  res.alphabet.insert("send_ack");
  res.alphabet.insert("rec_ack");
  /* variables */
  res.vars.insert("N");
  res.vars.insert("sdata");
  res.vars.insert("bdata");
  res.vars.insert("sbit");
  res.vars.insert("bbit");
  res.vars.insert("sack");
  res.vars.insert("back");
  res.vars.insert("rdata");
  res.vars.insert("rtbit");
  res.vars.insert("rbit");

  res.vars.insert("t");
  res.vars.insert("T");
  res.vars.insert("x");
  res.vars.insert("y");
  create_msat_variables(env,res.vars,msat_get_integer_type(env));
  /* init states */
  res.init_states.insert(0);
  /* final states */
  res.final_states.insert(1);
  /* create rules */
  create_rule(res.trans, env, 0, "tau", 1, __INIT);
  create_rule(res.trans, env, 1, "tau", 2, __S_01);
  create_rule(res.trans, env, 2, "tau", 3, __S_12);
  create_rule(res.trans, env, 3, "send_data", 4, __S_23__B_02);
  create_rule(res.trans, env, 4, "tau", 5, __S_32);
  create_rule(res.trans, env, 5, "tau", 3, __B_20);

  create_rule(res.trans, env, 4, "rec_data", 6, __B_20__R_01);
  create_rule(res.trans, env, 5, "rec_data", 7, __B_20__R_01);

  create_rule(res.trans, env, 6, "send_ack", 8, __B_01__R_10);
  create_rule(res.trans, env, 7, "send_ack", 10, __B_01__R_10);
  create_rule(res.trans, env, 10, "tau", 3, __B_10);

  create_rule(res.trans, env, 8, "rec_ack", 9, __S_34__B_10);
  create_rule(res.trans, env, 9, "tau", 3, __S_42);
  create_rule(res.trans, env, 9, "tau", 1, __S_40);

  create_rule(res.trans, env, 7, "send_data", 12, __S_23__B_02);
  create_rule(res.trans, env, 12, "tau", 11, __S_32);
  create_rule(res.trans, env, 12, "tau", 6, __B_20);
  create_rule(res.trans, env, 11, "tau", 7, __B_20);

  create_rule(res.trans, env, 8, "tau", 13, __B_10);
  create_rule(res.trans, env, 13, "tau", 3, __S_32);
  std::vector<automaton> res_v;		
  res_v.push_back(res);
  return res_v;
}

automaton get_rhs_automaton_concrete(msat_env env) {
  automaton res;
  /* alphabet */
  res.alphabet.insert("tau");
  res.alphabet.insert("send_data");
  res.alphabet.insert("rec_data");
  res.alphabet.insert("send_ack");
  res.alphabet.insert("rec_ack");
  /* variables */
  res.vars.insert("sbit");
  res.vars.insert("rbit");
  create_msat_variables(env,res.vars,msat_get_integer_type(env));
  /* init states */
  res.init_states.insert(0);
  /* final states */
  res.final_states.insert(1);
  /* create rules */
  create_rule(res.trans, env, 0, "tau", 0, "true");
  create_rule(res.trans, env, 0, "send_data", 0, "true");
  create_rule(res.trans, env, 0, "rec_data", 0, "true");
  create_rule(res.trans, env, 0, "send_ack", 0, "true");
  create_rule(res.trans, env, 0, "rec_ack", 0, "true");

  create_rule(res.trans, env, 0, "tau", 1, "(= sbit1 rbit1)");

  return res;
}
