#include "main.h"
#include "create_automata.h"

std::string BufSize="3";

std::vector<automaton> get_lhs_automaton_concrete(msat_env env) {
  /* producer */
  automaton producer;
  /* alphabet */
  producer.alphabet.insert("init");
  producer.alphabet.insert("produce");
  producer.alphabet.insert("wait_empty");
  producer.alphabet.insert("signal_full");
  /* variables */
  producer.vars.insert("empty");
  producer.vars.insert("full");
  create_msat_variables(env,producer.vars,msat_get_integer_type(env));
  /* init states */
  producer.init_states.insert(0);
  /* final states */
  producer.final_states.insert(1);
  /* create rules */
  create_rule(producer.trans,env,0,"init",1,"(and (= empty1 "+BufSize+") (= full1 0))");
  create_rule(producer.trans,env,1,"wait_empty",2,"(and (> empty0 0) (= empty1 (- empty0 1)) (= full1 full0))");
  create_rule(producer.trans,env,2,"produce",3,"(and (= empty1 empty0) (= full1 full0))");
  create_rule(producer.trans,env,3,"signal_full",1,"(and (= empty0 empty1) (= full1 (+ full0 1)))");
  /* consumer */
  automaton consumer;
  /* alphabet */
  consumer.alphabet.insert("init");
  consumer.alphabet.insert("consume");
  consumer.alphabet.insert("signal_empty");
  consumer.alphabet.insert("wait_full");
  /* variables */
  consumer.vars.insert("empty");
  consumer.vars.insert("full");
  create_msat_variables(env,consumer.vars,msat_get_integer_type(env));
  /* init states */
  consumer.init_states.insert(5);
  /* final states */
  consumer.final_states.insert(6);
  /* create rules */
  create_rule(consumer.trans,env,5,"init",6,"(and (= empty1 "+BufSize+") (= full1 0))");
  create_rule(consumer.trans,env,6,"wait_full",7,"(and (> full0 0) (= full1 (- full0 1)) (= empty1 empty0))");
  create_rule(consumer.trans,env,7,"consume",8,"(and (= empty1 empty0) (= full1 full0))");
  create_rule(consumer.trans,env,8,"signal_empty",6,"(and (= full0 full1) (= empty1 (+ empty0 1)))");
  std::vector<automaton> res_v;		
  res_v.push_back(producer);
  res_v.push_back(consumer);
  return res_v;
}

automaton get_rhs_automaton_concrete(msat_env env) {
  automaton res;
  /* alphabet */
  res.alphabet.insert("init");
  res.alphabet.insert("produce");
  res.alphabet.insert("wait_empty");
  res.alphabet.insert("signal_full");
  res.alphabet.insert("consume");
  res.alphabet.insert("signal_empty");
  res.alphabet.insert("wait_full");
  /* variables */
  res.vars.insert("empty");
  res.vars.insert("full");
  create_msat_variables(env,res.vars,msat_get_integer_type(env));
  /* init states */
  res.init_states.insert(0);
  /* final states */
  res.final_states.insert(1);
  /* create rules */
  create_rule(res.trans,env,0,"init",1,"(and (= empty1 "+BufSize+") (= full1 0))");
  create_rule(res.trans,env,1,"produce",1,"(and (= empty1 empty0) (= full1 full0))");
  create_rule(res.trans,env,1,"consume",1,"(and (= empty1 empty0) (= full1 full0))");
  create_rule(res.trans,env,1,"wait_full",1,"(and (> full0 0) (<= full0 "+BufSize+"))");
  create_rule(res.trans,env,1,"wait_empty",1,"(and (> empty0 0) (<= empty0 "+BufSize+"))");
  create_rule(res.trans,env,1,"signal_full",1,"(and (<= 0 full0) (< full0 "+BufSize+"))");
  create_rule(res.trans,env,1,"signal_empty",1,"(and (<= 0 empty0) (< empty0 "+BufSize+"))");


  return res;
}
