#include "main.h"

msat_term msat_exist_elim_bypass(msat_env env, msat_term formula,
                          msat_term *qvars, size_t num_vars_to_elim,
                          msat_exist_elim_algorithm algo) {

	msat_exist_elim_options opt;
	opt.remove_redundant_constraints=1;
	opt.boolean_simplifications=1;
	opt.toplevel_propagation=1;
	msat_term aux=msat_aig_simplify(env,formula);
	aux=msat_lra_simplify(env,aux);
	
	if (msat_term_is_true(env, aux)) return aux;
	msat_term aux1=msat_exist_elim(env,aux, qvars, num_vars_to_elim, algo,opt);
	if (!check_term_implication(env, formula,aux1,0)) {
		// Incorrect QE
		std::cout << "ERROR: QE bypass (from):"<<msat_term_repr(formula) << "\n";
		std::cout << "ERROR: QE bypass (from):"<<msat_term_repr(aux) << "\n";
		exit(1);
	}
	return aux1;

}
