#include "main.h"
#include "create_automata.h"


std::vector<automaton> get_lhs_automaton_concrete(msat_env env){
	std::cout << "EXAMPLE 2 (example2.c)\n";
	automaton res;
	std::vector<automaton> res_v;
	/* alphabet */
	res.alphabet.insert("a");
	res.alphabet.insert("b");
	/* variables */
	res.vars.insert("x");
	res.vars.insert("y");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* init states */
	res.init_states.insert(0);
	/* final states */
	res.final_states.insert(0);
	/* create rules */
	create_rule(res.trans,env,0,"a",1,"(and (= x1 (+ x0 1)) (= y1 y0))");
	create_rule(res.trans,env,1,"b",0,"(and (= x0 x1) (= y1 (+ y0 1)))");
	res_v.push_back(res);
	return res_v;

}

automaton get_rhs_automaton_concrete(msat_env env){
	automaton res;
	/* alphabet */
	res.alphabet.insert("a");
	res.alphabet.insert("b");
	/* variables */
	res.vars.insert("x");
	res.vars.insert("y");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* init states */
	res.init_states.insert(0);
	/* final states */
	res.final_states.insert(0);
	/* create rules */
	create_rule(res.trans,env,0,"a",0,"(<= x1 x0)");
	create_rule(res.trans,env,0,"b",0,"(<= x1 x0)");
	create_rule(res.trans,env,0,"a",1,"(and (> x1 x0) (<= y1 y0))");
	create_rule(res.trans,env,1,"b",0,"(> y1 y0)");


	return res;

}
