#include "main.h"
#include "create_automata.h"


std::vector<automaton> get_lhs_automaton_concrete(msat_env env){
	automaton res;
	std::vector<automaton> res_v;	
	/* alphabet */
	res.alphabet.insert("a");
	/* variables */
	res.vars.insert("x");
	res.vars.insert("y");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* init states */
	res.init_states.insert(0);
	/* final states */
	res.final_states.insert(1);
	/* create rules */
	create_rule(res.trans,env,0,"a",1,"(and (= 0 x1) (= y1 0))");
	create_rule(res.trans,env,1,"a",1,"(and (= x1 (+ x0 1)) (= y1 (+ y0 1)) )");
	/* add state invariants */
	//add_invariant(res,env,1,"(= x0 y0)");
	res_v.push_back(res);
	return res_v;

}

automaton get_rhs_automaton_concrete(msat_env env){
	automaton res;
	/* alphabet */
	res.alphabet.insert("a");
	/* variables */
	res.vars.insert("x");
	res.vars.insert("y");
	create_msat_variables(env,res.vars,msat_get_integer_type(env));
	/* init states */
	res.init_states.insert(0);
	/* final states */
	res.final_states.insert(0);
	/* create rules */
	create_rule(res.trans,env,0,"a",0,"(= x1 y1)");


	return res;

}
